---
title: CanvasRenderingContext2D.fillText()
slug: Web/API/CanvasRenderingContext2D/fillText
tags:
  - API
  - Canvas
  - CanvasRenderingContext2D
  - Draw String
  - Draw Text
  - Drawing Strings
  - Drawing Text
  - Fill Text
  - Filling Text
  - Method
  - Reference
  - Text
  - fillText
---
<div>{{APIRef("HTML DOM")}}</div>

<p>The {{domxref("CanvasRenderingContext2D")}} method <code><strong>fillText()</strong></code>, part of the Canvas 2D API, draws a text string at the specified coordinates, filling the string's characters with the current {{domxref("CanvasRenderingContext2D.fillStyle", "fillStyle")}}. An optional parameter allows specifying a maximum width for the rendered text, which the {{Glossary("user agent")}} will achieve by condensing the text or by using a lower font size.</p>

<p>This method draws directly to the canvas without modifying the current path, so any subsequent {{domxref("CanvasRenderingContext2D.fill()", "fill()")}} or {{domxref("CanvasRenderingContext2D.stroke()", "stroke()")}} calls will have no effect on it.</p>

<p>The text is rendered using the font and text layout configuration as defined by the {{domxref("CanvasRenderingContext2D.font","font")}}, {{domxref("CanvasRenderingContext2D.textAlign","textAlign")}}, {{domxref("CanvasRenderingContext2D.textBaseline","textBaseline")}}, and {{domxref("CanvasRenderingContext2D.direction","direction")}} properties.</p>

<div class="notecard note">
<p>To draw the outlines of the characters in a string, call the context's {{domxref("CanvasRenderingContext2D.strokeText", "strokeText()")}} method.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>CanvasRenderingContext2D</em>.fillText(<em>text</em>, <em>x</em>, <em>y</em> [, <em>maxWidth</em>]);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>text</code></dt>
 <dd>A {{domxref("DOMString")}} specifying the text string to render into the context. The text is rendered using the settings specified by {{domxref("CanvasRenderingContext2D.font","font")}}, {{domxref("CanvasRenderingContext2D.textAlign","textAlign")}}, {{domxref("CanvasRenderingContext2D.textBaseline","textBaseline")}}, and {{domxref("CanvasRenderingContext2D.direction","direction")}}.</dd>
 <dt><code>x</code></dt>
 <dd>The x-axis coordinate of the point at which to begin drawing the text, in pixels.</dd>
 <dt><code>y</code></dt>
 <dd>The y-axis coordinate of the point at which to begin drawing the text, in pixels.</dd>
 <dt><code>maxWidth</code> {{optional_inline}}</dt>
 <dd>The maximum number of pixels wide the text may be once rendered. If not specified, there is no limit to the width of the text. However, if this value is provided, the user agent will adjust the kerning, select a more horizontally condensed font (if one is available or can be generated without loss of quality), or scale down to a smaller font size in order to fit the text in the specified width.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>{{jsxref("undefined")}}.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Drawing_filled_text">Drawing filled text</h3>

<p>This example writes the words "Hello world" using the <code>fillText()</code> method.</p>

<h4 id="HTML">HTML</h4>

<p>First, we need a canvas to draw into. This code creates a context 400 pixels wide and 150 pixels across.</p>

<pre class="brush: html">&lt;canvas id="canvas" width="400" height="150"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript">JavaScript</h4>

<p>The JavaScript code for this example follows.</p>

<pre class="brush: js; highlight:[5]">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');

ctx.font = '50px serif';
ctx.fillText('Hello world', 50, 90);
</pre>

<p>This code obtains a reference to the {{HTMLElement("canvas")}}, then gets a reference to its 2D graphics context.</p>

<p>With that in hand, we set the {{domxref("CanvasRenderingContext2D.font", "font")}} to 50-pixel-tall "serif" (the user's default {{interwiki("wikipedia", "serif")}} font), then call <code>fillText()</code> to draw the text "Hello world," starting at the coordinates (50, 90).</p>

<h4 id="Result">Result</h4>

<p>{{ EmbedLiveSample('Drawing_filled_text', 700, 180) }}</p>

<h3 id="Restricting_the_text_size">Restricting the text size</h3>

<p>This example writes the words "Hello world," restricting its width to 140 pixels.</p>

<h4 id="HTML_2">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas" width="400" height="150"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript_2">JavaScript</h4>

<pre class="brush: js; highlight:[5]">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');

ctx.font = '50px serif';
ctx.fillText('Hello world', 50, 90, 140);
</pre>

<h4 id="Result_2">Result</h4>

<p>{{ EmbedLiveSample('Restricting_the_text_size', 700, 180) }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "scripting.html#dom-context-2d-filltext", "CanvasRenderingContext2D.fillText")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CanvasRenderingContext2D.fillText")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Canvas_API/Tutorial/Drawing_text">Drawing text</a></li>
 <li>{{domxref("CanvasRenderingContext2D")}}</li>
 <li>{{domxref("CanvasRenderingContext2D.strokeText()")}}</li>
</ul>
